import type { IRandom } from "@thi.ng/random";
import type { GridIterOpts2D } from "./api.js";
export interface RandomOpts2D extends GridIterOpts2D {
    /**
     * PRNG instance to use
     *
     * @defaultValue `SYSTEM`
     */
    rnd?: IRandom;
}
/**
 * Yields 2D grid coordinates in random order w/ support for optional
 * [`IRandom`](https://docs.thi.ng/umbrella/random/interfaces/IRandom.html)
 * implementation (default:
 * [`SYSTEM`](https://docs.thi.ng/umbrella/random/variables/SYSTEM.html) aka
 * `Math.random`).
 *
 * @param opts -
 */
export declare function random2d(opts: RandomOpts2D): Generator<import("./api.js").GridCoord2D, void, unknown>;
//# sourceMappingURL=random.d.ts.map